using CustomComponents.Helpers;
using WinFormForTest.TestClasses;

namespace WinFormForTest
{
    public partial class Form1 : Form
    {
        List<Plant> plants = new List<Plant>();
        public Form1()
        {
            InitializeComponent();
            customListBox1.AddToList(" 1");
            customListBox1.AddToList(" 2");
            customListBox1.AddToList(" 3");
            Plant pl1 = new Plant("", "", "");
            Plant pl2 = new Plant("", "", "");
            Plant pl3 = new Plant("", "", "");
            Plant pl4 = new Plant("", "", "");
            Plant pl5 = new Plant("", "", "");
            Plant pl6 = new Plant("", "", "");
            plants.Add(pl1);
            plants.Add(pl2);
            plants.Add(pl3);
            plants.Add(pl4);
            plants.Add(pl5);
            plants.Add(pl6);
            LoadTree();
        }

        public void LoadTree()
        {
            customTree1.Hierarcy = new List<string> { "Type", "Name", "Color" };
            foreach (Plant plant in plants)
            {
                customTree1.AddNode(plant);
            }
        }
        private void buttonClear_Click(object sender, EventArgs e)
        {
            customListBox1.Clear();
        }

        private void buttonCheck_Click(object sender, EventArgs e)
        {
            try
            {

                if (customComboBox1.TextBoxValue != null)
                {
                    checkBoxValid.Text = "";
                    checkBoxValid.Checked = true;
                    checkBoxValid.BackColor = Color.Green;
                }
            }
            catch (Exception ex)
            {
                checkBoxValid.Text = " ";
                checkBoxValid.Checked = false;
                checkBoxValid.BackColor = Color.Red;
                MessageBox.Show(ex.Message);
            }
        }

        private void buttonEnter_Click(object sender, EventArgs e)
        {
            customListBox1.AddToList(" 4");
            customListBox1.AddToList(" 5");
            customListBox1.AddToList(" 6");
        }

        private void buttonGet_Click(object sender, EventArgs e)
        {
            labelItem.Text = customListBox1.SelectedElement;
        }

        private void buttonPdfImage_Click(object sender, EventArgs e)
        {
            var res = openFileDialog1.ShowDialog(this);
            if (res != DialogResult.OK) return;
            var files = openFileDialog1.FileNames;
            openFileDialog1.Dispose();
            string path = "C:\\Users\\annal\\Desktop\\test_cop_lab2\\testImage.pdf";
            MessageBox.Show(path);
            if (pdfImage1.CreatePdfDoc(new DataForImage(path, "", files))) MessageBox.Show("Success!");
            else MessageBox.Show("Error");
        }

        private void buttonPdfTable_Click(object sender, EventArgs e)
        {
            List<Film> films = new List<Film>()
            {
                new Film("", ", , ", "1. 36.", "12+"),
                new Film(" ", ", , ", "2. 7.", "18+"),
                new Film("", ", , , ", "2. 58.", "18+"),
                new Film("", ", , , ", "2. 1.", "18+")
            };

            List<(int, int)> merges = new List<(int, int)>();
            merges.Add((1, 2));

            List<int> heights = new List<int> { 10, 80, 30, 50, 25, 25 };

            string path = "C:\\Users\\annal\\Desktop\\test_cop_lab2\\testTable.pdf";

            List<(string, string)> headers = new List<(string, string)>
            {
                ("id", "Id"),
                ("", ""),
                ("Name", ""),
                ("Ganre", ""),
                ("Duration", ""),
                ("AgeRange", " ")
            };

            if (pdfTable1.createTable(new DataForTable<Film>(path, " ", heights, merges, headers, films)))
            {
                MessageBox.Show("Success!");
            }
        }

        private void buttonPdfChart_Click(object sender, EventArgs e)
        {
            string path = "C:\\Users\\annal\\Desktop\\test_cop_lab2\\testPieChart.pdf";
            List<(double, string)> elements = new List<(double, string)>
                {
                    (20, ""),
                    (37, ""),
                    (10, ""),
                    (15, ""),
                    (18, "")
                };

            if (pdfPieChart1.CreatePieChart(new DataForPieChart(path, " ", "  100 ", DiagramLegendEnum.Bottom, "", elements)))
            {
                MessageBox.Show("Success!");
            }
        }
    }
}
